config/routes.rb
Rails.application.routes.draw do

  root 'posts#index'

  devise_for :users, controllers: { omniauth_callbacks: 'callbacks' } 

  resources :users, only: [:show, :index]

  resources :posts

  resources :comments

  resources :likes

  resources :friendships

  get :pending_requests, to: 'friendships#pending'
end

app/models/post.rb
# frozen_string_literal: true

class Post < ApplicationRecord
  belongs_to :user
  has_many :comments, dependent: :destroy
  has_many :likes, dependent: :destroy

  default_scope -> { order(created_at: :desc) }

  validates :user_id, presence: true
  validates :content, presence: true
end

app/controllers/posts_controller.rb
# frozen_string_literal: true

class PostsController < ApplicationController
  before_action :authenticate_user!
  # before_action :post_id, only: %i[destroy edit update]
  before_action :correct_user, only: %i[destroy edit update]

  def index
    @posts = current_user.feed
    @post = current_user.posts.build
  end

  def create
    @post = current_user.posts.build(post_params)
    if @post.save
      flash[:success] = 'Post was successfully created'
      redirect_to root_url
    else
      @posts = current_user.feed
      render 'index'
    end
  end

  def edit; end

  def update
    if @post.update(post_params)
      flash[:success] = 'Post updated successfully'
      redirect_to root_path
    else
      flash.now[:warning] = 'Something went wrong, post not edited'
      render 'edit'
    end
  end

  def destroy
    @post.delete
    flash[:success] = 'Post deleted successfully'
    redirect_to root_url
  end

  private

  def post_id
    @post = Post.find_by(id: params[:id])
  end

  def post_params
    params.require(:post).permit(:content)
  end

  def correct_user
    post_id
    return if @post && current_user == @post.user

    redirect_to root_path
  end
end

app/helpers/posts_helper.rb
# frozen_string_literal: true

module PostsHelper
end

app/views/posts/_post.html.erb
<div class="posts">
  <header>
    <div class="name-container">
      <h3 class="post-user-name"><%=link_to post.user.name, user_path(post.user)%></h3>
      <time class="post-time" datetime="<%=post.created_at%>"><%= time_ago_in_words(post.created_at) %>
        ago.
      </time>
    </div>
    <% if post.user == current_user %>
      <div class="dropdown">
        <button class="dropbtn">
          <i class="fas fa-ellipsis-v"></i>
        </button>
        <div class="dropdown-content">
          <%= link_to 'Edit', edit_post_path(post.id) %>
          <%= link_to 'Delete', post_path(post.id), method: :delete %>
        </div>
      </div>
    <% end %>

  </header>
  <p class="post-content"><%= post.content %></p>
  <div class="count">
    <span class="likes-count"><%= render 'like_unlike', post: post %>
      <span><%= post.likes.count if post.likes.any? %></span>
    </span>
    <span class="comments-count"><%= render 'comment_icon' %>
      <%= post.comments.count if post.comments.any? %></span>
  </div>

  <% if post.comments.any? %>
    <%= render post.comments %>
  <% end %>

  <%= render 'comments/new_comment', post: post %>
</div>

app/views/posts/edit.html.erb
<div class="container">
  <h3>Update your post</h3>
  <div class="row">
    <%= form_for @post, html: { class: 'col-md-6', method: :patch } do |f| %>
    <%= render 'error_messages', object: f.object %>
    <%= f.text_area :content, class: "post-textarea"%>
    <%= f.submit "Update post", class: "btn btn-primary" %>
    <% end %>
  </div>
</div>

app/views/posts/index.html.erb
<div class="feed-container">

  <div class="friends-container">
    <% if current_user.friends.any? %>
      <h4><%= pluralize(current_user.friends.count, "Friend") %></h4>
    <% else %>
      <h4>You don't have any friends yet</h4>
    <% end %>
    <ul>
      <% current_user.friends.each do |friend| %>
        <%= render 'friends_container', user: friend %>
      <% end %>
    </ul>
  </div>

  <%= form_for(@post) do |f| %>
  <%= render 'error_messages', object: f.object %>
  <%= f.text_area :content, placeholder: "What's in your mind, #{current_user.name}?", class: "post-textarea"%>
  <%= f.submit "Post", class: "btn btn-primary" %>
<% end %>

<div class="posts-container">
  <%= render @posts %>
</div>

</div>